# ionoscloud\_s3\_object\_lock\_configuration

Manages Object Lock Configuration for Buckets on IONOS CLOUD.

## Example Usage

```hcl
resource "ionoscloud_s3_bucket" "example" {
  name = "example"
  object_lock_enabled = true
}

resource "ionoscloud_s3_bucket_object_lock_configuration" "test" {
  bucket = ionoscloud_s3_bucket.example.name
  object_lock_enabled = "Enabled"
  rule {
    default_retention {
      mode = "GOVERNANCE"
      days = 1
    }
  }
}
```

## Argument Reference

The following arguments are supported:

* `bucket` - (Required)\[string] The name of the bucket where the object will be stored.
* `object_lock_enabled` - (Required)\[Optional] The object lock configuration status of the bucket. Must be `Enabled`.
* `rule` - (Optional)\[block] A block of rule as defined below.
  * `default_retention` - (Required)\[block] A block of default\_retention as defined below.
    * `mode` - (Optional)\[string] The default retention mode of the bucket. Can be `GOVERNANCE` or `COMPLIANCE`.
    * `days` - (Optional)\[int] The default retention period of the bucket in days.
    * `years` - (Optional)\[int] The default retention period of the bucket in years.

Days and years are mutually exclusive. You can only specify one of them.

## Import

IONOS Object Storage Bucket object lock configuration can be imported using the `bucket` name.

```shell
terraform import ionoscloud_s3_bucket_object_lock_configuration.example example
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/terraform-provider/resources/s3_bucket_object_lock_configuration.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
